#include "mbed.h"
#include "DHT.h"
#include "HX711.h"
#include "DS1820.h"

#define MULTIPLE_PROBES
#define DATA_PIN        A0
#define MAX_PROBES      16
DS1820* probe[MAX_PROBES];
 
AnalogIn loudness(A1);
//DS1820 probe(A0);         // Port pour l'entrée des donnée de la sonde 
DigitalOut myled(LED1);
Serial pc(USBTX,USBRX);     // Déclaration du port série USB
Serial device(D1,D0);       // Port RX TX du Module Sigfox 
HX711 Balance(D5,D6);       // Port pour le Module  HX711
DHT sensor(D4,DHT11);       // Port et selection du  DHT22 sensor
DHT sensor2(D3,DHT22);       // Port et selection du  DHT22 sensor
DigitalOut Done(D2);        //Pin Done Timer 

int main() {
    int err;
    int err2;
    device.baud(9600);  
    long valeur;
    long valeurTare ;
    float poids;
    ////////////////////////////////////Initilalisation //////////////////////////////////////////////////////////    
    valeurTare = Balance.getValue();  //Calibration de la balance     
    
    ////////////////////////////////////Initialisation de la sonde ///////////////////////////////////////////////
    // Initialize the probe array to DS1820 objects
    int num_devices = 0;
    while(DS1820::unassignedProbe(DATA_PIN)) {
        probe[num_devices] = new DS1820(DATA_PIN);
        num_devices++;
        if (num_devices == MAX_PROBES)
            break;
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    wait(1); // wait 1 second for device stable status
    
    
    //////////////////////////Debut de teste //////////////////////
        while (1) {
        //////////////////////////////////////Lecture de la température et l'humidité /////////////////////////////////////////
        wait(0.01);  
        Done = 0 ;
        
        myled = 1;
        err2 = sensor2.readData();
        err = sensor.readData();
        if (err == 0) {
            pc.printf("\r\n Temperature is %4.2f C \r\n",sensor.ReadTemperature(CELCIUS));
           
            pc.printf("Humidity is %4.2f \r\n",sensor.ReadHumidity());
        } else
        printf("\r\n Err %i \r\n",err);
        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        wait(1);
        //////////////////////////////Recuperation du poid ////////////////////////////////////////////////////////////////////////////////////////////////////////
            valeur = Balance.getValue();                                        // On récupère la valeur du module
            poids = ((double)valeur-(double)valeurTare)/11500;         // Convertionde la valeur de l'ADC en grammes
            pc.printf("Poid : Valeur : %ld   valeurTar: %ld      Poids : %.3lf\n\r",valeur,valeurTare,poids);    // Affichage du poids
        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
        
                    
        //////////////////////////////Temperature a partire de la sonde ///////////////////////////////////////////////////////////////////////////////////////////    
        probe[0]->convertTemperature(true, DS1820::all_devices);         //Start temperature conversion, wait until ready
        for (int i = 0; i<num_devices; i++){
        printf("Sonde %d returns %3.1foC\r\n", i, probe[i]->temperature());
        }
        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        wait(1);           
        
        ////////////////////////////////////////////////Micro ///////////////////////////////////////// 
        float res;
        float db;
        res = loudness.read() * 1023;
        db = 20.0* log10(res/39.0)+27.0;
        printf("Micro returns %3.1f dB\r\n",db);
       // pc.printf("Poid : Valeur : %ld   valeurTar: %ld      Poids : %.3lf\n\r",valeur,valeurTare,poids);    
        //device.printf("Poid : Valeur : %ld   valeurTar: %ld      Poids : %.3lf\n\r",valeur,valeurTare,poids);
        //device.printf(" temperature %d ",(int)sensor.ReadTemperature(CELCIUS));           
        /////////////////////////////Envoi des données via Sigfox et sur le terminale /////////////////////////////////////////////////////////////////////////////   
      //pc.printf("AT$SF=%02X%02X%02X%02X%02X\r\n",((int)(sensor.ReadTemperature(CELCIUS))),((int)(sensor.ReadHumidity())),((float)(poids)),((int)(probe[0]->temperature()*100)),(int)db);
       device.printf("AT$SF=%02x%02x%02x%02x%02x\r\n",(int)sensor.ReadTemperature(CELCIUS),(int)probe[0]->temperature(),(int)poids,(int)sensor2.ReadHumidity(),(int)db);
        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
        ///(int)probe[0]->temperature() 
             
                wait(2);
                 myled = 0; // LED is OFF
                  wait(1);  
                 Done = 1 ; 
                   
    }
 
}